VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "asmCryption"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source!


'---------------------------------------------------------------------------------------
' Module    : asmCryption
' Author    : (softKUS) - I/2004
'---------------------------------------------------------------------------------------
Option Base 0
Option Explicit
Option Compare Text

' s. also: http://www.itl.nist.gov/fipspubs/fip180-1.htm
'
Const def_flg = 72
Const def_len = 73

Dim asm()   As Long
Dim def()   As Long

Private Declare Sub API_CopyByRef _
    Lib "kernel32" Alias "RtlMoveMemory" _
   (ByRef hpvDest As Any, _
    ByRef hpvSource As Any, _
    ByVal cbCopy As Long)

Private Declare Function ASM_Hash _
    Lib "user32" Alias "CallWindowProcA" _
   (ByRef asm As Long, _
    ByVal src As Long, _
    ByVal ref As Long, _
    ByRef tgt As Long, _
    ByRef def As Long) As Long

Private Sub Class_Initialize()
    ReDim asm(124)
    ReDim def(73)

    ' program code
    asm(0) = &HEC8B5590:  asm(1) = &H8B575653:  asm(2) = &H968B1475
    asm(3) = &H120:       asm(4) = &H124868B:   asm(5) = &H50520000
    asm(6) = &H1A8EC81:   asm(7) = &HC2F60000:  asm(8) = &HA81D7401
    asm(9) = &HBC850F3F:  asm(10) = &HC1000001: asm(11) = &H840F06E8
    asm(12) = &H1B3:      asm(13) = &HC7E84589: asm(14) = &HFFFFE445
    asm(15) = &H52EBFFFF: asm(16) = &H8A09C083: asm(17) = &H6E8C1C8
    asm(18) = &H743FC1F6: asm(19) = &H45894001: asm(20) = &H24BC8DE8
    asm(21) = &H120:      asm(22) = &HB9EC758B: asm(23) = &H3F
    asm(24) = &HF133CE23: asm(25) = &H3E47589:  asm(26) = &H37BB0875
    asm(27) = &H2B000000: asm(28) = &H830373D9: asm(29) = &HA4F340C3
    asm(30) = &H478007C6: asm(31) = &HCB8AC18A: asm(32) = &H458BAAF3
    asm(33) = &HF708B1EC: asm(34) = &HFCA0FE1:  asm(35) = &H891789C8
    asm(36) = &H7D8B0447: asm(37) = &H14758B10: asm(38) = &H100C681
    asm(39) = &H8B90000:  asm(40) = &HF3000000: asm(41) = &H8558BA5
    asm(42) = &H40E46D83: asm(43) = &H948D0773: asm(44) = &H12024
    asm(45) = &H8BFC8B00: asm(46) = &H8B11075:  asm(47) = &HDF8BA5F3
    asm(48) = &HFB1F28B:  asm(49) = &H1F045F7:  asm(50) = &H75000000
    asm(51) = &H8E048B0B: asm(52) = &H489C80F:  asm(53) = &HF579498F
    asm(54) = &H8BA5F341: asm(55) = &HD23352F4: asm(56) = &H7240FA83
    asm(57) = &HF8438B32: asm(58) = &HF88BC88B: asm(59) = &HC111C8C1
    asm(60) = &HEFC113C9: asm(61) = &H33C1330A: asm(62) = &H8B0389C7
    asm(63) = &HC88BC443: asm(64) = &HC8C1F88B: asm(65) = &H12C9C107
    asm(66) = &H3303EFC1: asm(67) = &H3C733C1:  asm(68) = &H4303E443
    asm(69) = &H8B0301C0: asm(70) = &HF88B1046: asm(71) = &HF7144623
    asm(72) = &H187E23D7: asm(73) = &H468BF833: asm(74) = &HC1C88B10
    asm(75) = &HC9C106C8: asm(76) = &HC1C1330B: asm(77) = &HC1330EC9
    asm(78) = &H7D8BC703: asm(79) = &H3A040314: asm(80) = &H31C4603
    asm(81) = &H68B5003:  asm(82) = &H4623F88B: asm(83) = &H87E2304
    asm(84) = &H7E8BC733: asm(85) = &H87E2304:  asm(86) = &H68BF833
    asm(87) = &HC8C1C88B: asm(88) = &HDC9C102:  asm(89) = &HC9C1C133
    asm(90) = &H3C13309:  asm(91) = &H7E8D50C7: asm(92) = &H18C6831C
    asm(93) = &H7B9:      asm(94) = &HA5F3FD00: asm(95) = &H8FF78BFC
    asm(96) = &H6015806:  asm(97) = &H83104601: asm(98) = &HC28004C3
    asm(99) = &H4D830F04: asm(100) = &H8BFFFFFF: asm(101) = &H7B1107D
    asm(102) = &H18E048B: asm(103) = &H79498F04: asm(104) = &H8B5A41F7
    asm(105) = &HEB830C7D: asm(106) = &HF70FB140: asm(107) = &H1F045
    asm(108) = &H1C740000: asm(109) = &H318B048B: asm(110) = &H4318F04
    asm(111) = &HF479498A: asm(112) = &HC458341: asm(113) = &HE84DFF40
    asm(114) = &HFEE7850F: asm(115) = &H16EBFFFF: asm(116) = &H318B048B
    asm(117) = &H79498F04: asm(118) = &HC28341F7: asm(119) = &HE84DFF40
    asm(120) = &HFEC2850F: asm(121) = &H8DF9FFFF: asm(122) = &HC01BF465
    asm(123) = &H5D5B5E5F: asm(124) = &H10C2
    
    ' dwords for manipulation loop (K)
    def(0) = &H428A2F98:  def(1) = &H71374491:  def(2) = &HB5C0FBCF
    def(3) = &HE9B5DBA5:  def(4) = &H3956C25B:  def(5) = &H59F111F1
    def(6) = &H923F82A4:  def(7) = &HAB1C5ED5:  def(8) = &HD807AA98
    def(9) = &H12835B01:  def(10) = &H243185BE: def(11) = &H550C7DC3
    def(12) = &H72BE5D74: def(13) = &H80DEB1FE: def(14) = &H9BDC06A7
    def(15) = &HC19BF174: def(16) = &HE49B69C1: def(17) = &HEFBE4786
    def(18) = &HFC19DC6:  def(19) = &H240CA1CC: def(20) = &H2DE92C6F
    def(21) = &H4A7484AA: def(22) = &H5CB0A9DC: def(23) = &H76F988DA
    def(24) = &H983E5152: def(25) = &HA831C66D: def(26) = &HB00327C8
    def(27) = &HBF597FC7: def(28) = &HC6E00BF3: def(29) = &HD5A79147
    def(30) = &H6CA6351:  def(31) = &H14292967: def(32) = &H27B70A85
    def(33) = &H2E1B2138: def(34) = &H4D2C6DFC: def(35) = &H53380D13
    def(36) = &H650A7354: def(37) = &H766A0ABB: def(38) = &H81C2C92E
    def(39) = &H92722C85: def(40) = &HA2BFE8A1: def(41) = &HA81A664B
    def(42) = &HC24B8B70: def(43) = &HC76C51A3: def(44) = &HD192E819
    def(45) = &HD6990624: def(46) = &HF40E3585: def(47) = &H106AA070
    def(48) = &H19A4C116: def(49) = &H1E376C08: def(50) = &H2748774C
    def(51) = &H34B0BCB5: def(52) = &H391C0CB3: def(53) = &H4ED8AA4A
    def(54) = &H5B9CCA4F: def(55) = &H682E6FF3: def(56) = &H748F82EE
    def(57) = &H78A5636F: def(58) = &H84C87814: def(59) = &H8CC70208
    def(60) = &H90BEFFFA: def(61) = &HA4506CEB: def(62) = &HBEF9A3F7
    def(63) = &HC67178F2

    ' Initial hash values
    def(64) = &H6A09E667: def(65) = &HBB67AE85: def(66) = &H3C6EF372
    def(67) = &HA54FF53A: def(68) = &H510E527F: def(69) = &H9B05688C
    def(70) = &H1F83D9AB: def(71) = &H5BE0CD19

    ' Parameters
    def(72) = 0     ' flags
    def(73) = 0     ' message length
End Sub

' Crypt     Encryption/Decryption
'
' CALL:     Crypt(src, @tgt, pwd, cmd, [F1:AddSHA], [F2:AddTime], [F3:AddText])
'
' IN:       bar:src Sourcedata
'           bar:tgt Targetdata
'           chr:pwd Password
'           bol:cmd .F.: Encrypt
'                   .T.: Decrypt
'           lng:F1  SHA-DWords to be appended (0 to 8)
'           bol:F2  Timestamp to be used?
'           chr:F3  Identifier-string to be appended
'
' OUT:      bol     success
'
Public Function Crypt( _
    src() As Byte, _
    tgt() As Byte, _
    pwd As String, _
    cmd As Boolean, _
    Optional AddSHA As Long = 8, _
    Optional AddTime As Boolean = True, _
    Optional AddText As String = "") As Boolean
    
    Static svd  As Long         ' stored timestamp
    
    Dim txt     As String       ' temp
    Dim bar()   As Byte         ' temp
    Dim msg()   As Long         ' standardized message
    Dim sha(8)  As Long         ' hash (+Timestamp)
    Dim tmp(8)  As Long         ' password validation
    Dim ref(63) As Byte         ' xor message...
    Dim flg     As Boolean      ' password okay?
    Dim UBsrc   As Long         ' UBound(src)+1
    Dim UBtgt   As Long         ' UBound(tgt)+1
    Dim TxLen   As Long         ' Len(AddText)
    Dim ToAdd   As Long         ' onDecrypt: decrease,
                                ' onEncrypt: increase msglen
    
    If x_arrDIM(src) <> 1 Then
        ' invalid no of dimensions
        
    Else
        ' initialize values, create hash(pwd)
        UBsrc = UBound(src) + 1
        x_Hash StrConv(pwd, vbFromUnicode), ref, sha, False
        
        ' calculate number of additional bytes
        ' (info to be appended/deleted on encryption/decryption)
        If AddSHA Then AddSHA = ((AddSHA - 1) And 7) + 1
        TxLen = Len(AddText)
        ToAdd = AddSHA * 4 _
              + (AddTime And 4) _
              + TxLen
        UBtgt = UBsrc + IIf(cmd, -ToAdd, ToAdd)
        
           ' on encrypt: get timestamp, if required
        If cmd = False Then
            If AddTime Then
                ' ensure to get an unique value
                sha(AddSHA) = DateDiff("s", DateSerial(1970, 1, 1), Now)
                If sha(AddSHA) <= svd Then sha(AddSHA) = svd + 1
                svd = sha(AddSHA)
            End If
            
           ' on decrypt: get info from file, check password
        ElseIf UBsrc > ToAdd Then
            flg = True  ' assume no password-check required
            
               ' if available, copy sha and timestamp from src
            If ToAdd > TxLen Then
                API_CopyByRef tmp(0), src(UBsrc - ToAdd), ToAdd - TxLen
                If AddTime Then sha(AddSHA) = tmp(AddSHA)
                
                ' check password, if sha was added
                If AddSHA Then flg = lngCMP(sha(0), tmp(0), AddSHA - 1)
            End If
        End If
        
        If cmd Imp flg Then
            ' create hash(hash+timestamp+pwd)
            txt = LNG2CHR(sha(0), 8)
            x_Hash StrConv(txt & pwd, vbFromUnicode), ref, tmp, False
        
            ' En/Decrypt message
            ReDim tgt(((UBtgt + 63) And -64&) - 1)
            API_CopyByRef tgt(0), src(0), UBsrc - IIf(cmd, ToAdd, 0)
            x_Hash ref, tgt, tmp, True
        
            ' onEncode: append admin info
            If cmd = False And ToAdd > 0 Then
                txt = Left$(txt, AddSHA * 4 + (AddTime And 4)) & AddText
                bar = StrConv(txt, vbFromUnicode)
                API_CopyByRef ByVal VarPtr(tgt(0)) + UBsrc, bar(0), ToAdd
            End If
            
            ' adjust length
            ReDim Preserve tgt(UBtgt - 1)
            Crypt = True
        End If
    End If
End Function

Public Function Hash(src() As Byte) As Long()
    Dim tgt(7)  As Long
    Dim ref(63) As Byte
    
    If x_Hash(src, ref, tgt, False) Then
        Hash = tgt
    End If
End Function

Private Function x_arrDIM(arr) As Long
    Dim N1 As Long
    Dim N2 As Long
    
    If IsArray(arr) Then
        API_CopyByRef N1, ByVal VarPtr(arr), 2
        API_CopyByRef N2, ByVal VarPtr(arr) + 8, 4
        If N1 And &H4000 Then API_CopyByRef N2, ByVal N2, 4
        If N2 Then API_CopyByRef N1, ByVal N2, 2
        
        If N2 Then x_arrDIM = N1
    End If
End Function

Private Function x_Hash( _
    src() As Byte, _
    ref() As Byte, _
    sha() As Long, _
    flg As Boolean) As Boolean
    
    def(def_flg) = (flg And 1)
    def(def_len) = IIf(flg, UBound(ref), UBound(src)) + 1
    
    x_Hash = ASM_Hash(asm(0), _
                      VarPtr(src(0)), _
                      VarPtr(ref(0)), _
                      sha(0), _
                      def(0))
End Function

